// The contents of this file are subject to the Mozilla Public License Version 1.1
// (the "License"); you may not use this file except in compliance with the License.
// You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
// 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
// WARRANTY OF ANY KIND, either express or implied. See the License for the specific
// language governing rights and limitations under the License.
// 
// The Original Code is the Venice Web Communities System.
// 
// The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
// for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
// Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
// 
// Contributor(s): 

importPackage(java.util);
importPackage(Packages.com.silverwrist.venice.core);
importPackage(Packages.com.silverwrist.venice.except);
importPackage(Packages.com.silverwrist.venice.ui);
importPackage(Packages.com.silverwrist.venice.ui.helpers);
importPackage(Packages.com.silverwrist.venice.ui.view);

// get the request object and the community
rinput = bsf.lookupBean("request");
comm = rinput.getCommunity(true,"top.js.vs");

if (!(comm.canMassMail()))
{ // we can't send mass mail to the community, so what are we doing here?
  logger.error("you can't mass-mail the community - not gonna do it, wouldn't be prudent");
  vlib.output(new ErrorBox("Access Error","You do not have permission to sent mass mail to this community.",
			   "comm/admin_menu.js.vs?cc=" + comm.communityID));
  vlib.done();

} // end if

if ("GET"==rinput.verb)
{ // display the view
  view = new JSPView("Community E-Mail: " + comm.name,"comm/email.jsp");
  view.menuSelector = Content.MENU_SELECTOR_COMMUNITY;
  vlib.output(view);
  vlib.done();

} // end if

if (rinput.isImageButtonClicked("cancel"))
{ // user cancelled - go back to the menu
  vlib.output(new Redirect("comm/admin_menu.js.vs?cc=" + comm.communityID,LinkTypes.SERVLET));
  vlib.done();

} // end if

rc = null;
if (rinput.isImageButtonClicked("send"))
{ // actually send the E-mail!
  try
  { // do it!
    comm.massMail(rinput.getParameter("subj"),rinput.getParameter("pb"));

    // now bounce back to the menu
    rc = new Redirect("comm/admin_menu.js.vs?cc=" + comm.communityID,LinkTypes.SERVLET);

  } // end try
  catch (e)
  { // exception caught in the mass mailing
    etype = vlib.exceptionType(e) + "";
    if (etype.match("DataException"))
      rc = new ErrorBox("Database Error","Database error getting mailing list: " + e.message,
			"comm/admin_menu.js.vs?cc=" + comm.communityID);
    else if (etype.match("AccessError"))
      rc = new ErrorBox("Access Error",e.message,"comm/admin_menu.js.vs?cc=" + comm.communityID);
    else
      rc = e;

  } // end catch

} // end try
else
{ // what the hell was that button
  logger.error("no known button click on POST to comm/email.js");
  rc = new ErrorBox("Internal Error","Unknown command button pressed",
                    "comm/admin_menu.js.vs?cc=" + comm.communityID);

} // end else

vlib.output(rc);
